/*
   High Dynamic Range Rendering - Using P Buffers
   Allen Sherrod
   Article for the Game Developers Magazine.
*/


varying vec2 texCoords;

uniform sampler2D fullTexture;
uniform float exposure;


void main()
{
   float gamma = 0.55f;
   vec4 scenePass = texture2D(fullTexture, texCoords);

   // Increase the color by the exposure then use a power
   // to convert to LDR range.
   scenePass = scenePass * exposure;
   gl_FragColor = pow(scenePass, gamma);
}